#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;

#define For(i,a , n)for(ll i = a;i<(ll)n;i++)
#define vec vector
#define all(x) begin(x), end(x)
#define sz(x)(ll)size(x)

template<class A, class B>
pair<A, B> operator+(const pair<A, B>& a, const pair<A, B>& b){
    return {a.first + b.first, a.second + b.second};
}

template<class A, class B>
ostream& operator<<(ostream& os, const pair<A, B>& a){
    return os<<"("<<a.first<<", "<<a.second<<")";
}

template<class A, class B, class C>
basic_ostream<A, B>& operator<<(basic_ostream<A, B>& os, const C& c){
    for(auto itr = begin(c);itr!=end(c);++itr){
        os<<(itr==begin(c)?"":" ")<<*itr;
    }
    return os;
}

template<typename... Args>
void dbg(Args&&... args){
    ((cerr<<args<<"| "),...);
    cerr<<endl;
}

void solve(){
    ll n, k;cin>>n>>k;
    vec<ll> a(n);
    for(auto & i : a)cin>>i;
    sort(all(a));
    ll lo = 0, hi = n;
    while(hi-lo>1){
        ll m = (hi + lo)/2;
        if(m%2)m--;
        ll ok = true;
        For(i, 0, m){
            ll d = m  - i;
            if(d <i)break;
            if(a[i] + a[d]>k) ok = false;
        }
        if(ok)lo = m;
        else hi = m;
    }

    ll res = n - 1;
    For(i, 0, n){
        if(a[i] >=k)break;
         ll x = (min(i, lo)+1)/2;

        if(i-x <= n-i)
        {
            // dbg(i, x);
            res = min(res, n-i-1);
        }
    }
    cout << res << '\n';
}

int main(){
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);
    ll t = 1; // cin>>t;
    while(t--)solve();
}